import processing.serial.*;

Serial myPort;
byte[] inBuffer;
color background;
color foreground;

PImage scrn;
PImage img;

void setup(){
  size(1024, 512);   
  printArray(Serial.list());
  myPort = new Serial(this, Serial.list()[1], 9600);
  background = color(0,0,0);
  foreground = color(0,255,0);
  inBuffer = new byte[1024];  
  frameRate(60);
  surface.setResizable(true);
  scrn = new PImage(128,64);
  background(background);
  noSmooth();
}

void draw(){  
  while (myPort.available() > 0) {
    inBuffer = myPort.readBytes();
    myPort.readBytes(inBuffer);    
    
    scrn.loadPixels();
    for(int i=0; i<127*63; i++){
      scrn.pixels[i] = background;
    }
    scrn.updatePixels();
    
    if (inBuffer != null) {        
        for(int i=0; i<1024; i++){
          int b = i/128;
          if(inBuffer[i] != 0){
            for(int j=0; j<8; j++){              
              scrn.set(i%128,j+b*8,((inBuffer[i] >> j & 1 ) == 1)?foreground:background);              
            }
          }
         }                       
    }
  }
  img = scrn.copy();
  img.resize(width,width/2);
  image(img,0,0);
  println(frameRate);
}