import processing.serial.*;

Serial myPort;
byte[] inBuffer;
color background;
color foreground;
float scale = 4;

void setup(){
  size(512, 1024);
  printArray(Serial.list());
  myPort = new Serial(this, Serial.list()[1], 9600);
  background = color(204,204,204);
  foreground = color(153,0,255);
  inBuffer = new byte[1024];  
  frameRate(60);
  noStroke();
}

void draw(){
  scale = round(height/128.0);
  while (myPort.available() > 0) {    
    inBuffer = myPort.readBytes();
    myPort.readBytes(inBuffer);
    background(background);
    if (inBuffer != null) {        
        for(int i=0; i< inBuffer.length; i++){          
          if(inBuffer[i] != 0){
            for(int j=0; j<8; j++){
              if((inBuffer[i] >> j & 1 ) == 1){                             
                //fill(random(0,255),random(0,255),random(0,255));
                fill(foreground);
              }
              else{
                fill(background);
              }
              float x = (i%128)*scale;
              float y = scale*(j+floor(i/128)*8); 
              rect(y,height-scale-x,scale,scale);
            }
          }
         }                       
    }    
  }
}